# coding: utf-8

"""
    Enterprise Mission Assurance Support Service (eMASS)

    The eMASS Representational State Transfer (REST) Application Programming Interface (API) enables users to perform assessments and complete actions associated with system records.  The eMASS API provides an interface for application to communicate eMASS Services. For information on how to register and use the eMASS API reference the [eMASS API Getting Started](eMASSGettingStarted.md).  Additional information about eMASS can be obtain by contacting the National Industrial Security Program (NISP). Points of Contact are: 

    The version of the OpenAPI document: v3.22
    Contact: disa.global.servicedesk.mbx.ma-ticket-request@mail.mil
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ControlsReadOnlyFields(BaseModel):
    """
    ControlsReadOnlyFields
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="[Read-only] Name of the system record.")
    ccis: Optional[StrictStr] = Field(default=None, description="[Read-only] Comma separated list of CCIs associated with the control.")
    is_inherited: Optional[StrictBool] = Field(default=None, description="[Read-only] Indicates whether a control is inherited.", alias="isInherited")
    modified_by_overlays: Optional[StrictStr] = Field(default=None, description="[Read-only] List of overlays that affect the control.", alias="modifiedByOverlays")
    included_status: Optional[StrictStr] = Field(default=None, description="[Read-only] Indicates the manner by which a control was included in the system's categorization.", alias="includedStatus")
    compliance_status: Optional[StrictStr] = Field(default=None, description="[Read-only] Compliance of the control.", alias="complianceStatus")
    __properties: ClassVar[List[str]] = ["name", "ccis", "isInherited", "modifiedByOverlays", "includedStatus", "complianceStatus"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ControlsReadOnlyFields from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if ccis (nullable) is None
        # and model_fields_set contains the field
        if self.ccis is None and "ccis" in self.model_fields_set:
            _dict['ccis'] = None

        # set to None if is_inherited (nullable) is None
        # and model_fields_set contains the field
        if self.is_inherited is None and "is_inherited" in self.model_fields_set:
            _dict['isInherited'] = None

        # set to None if modified_by_overlays (nullable) is None
        # and model_fields_set contains the field
        if self.modified_by_overlays is None and "modified_by_overlays" in self.model_fields_set:
            _dict['modifiedByOverlays'] = None

        # set to None if included_status (nullable) is None
        # and model_fields_set contains the field
        if self.included_status is None and "included_status" in self.model_fields_set:
            _dict['includedStatus'] = None

        # set to None if compliance_status (nullable) is None
        # and model_fields_set contains the field
        if self.compliance_status is None and "compliance_status" in self.model_fields_set:
            _dict['complianceStatus'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ControlsReadOnlyFields from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "ccis": obj.get("ccis"),
            "isInherited": obj.get("isInherited"),
            "modifiedByOverlays": obj.get("modifiedByOverlays"),
            "includedStatus": obj.get("includedStatus"),
            "complianceStatus": obj.get("complianceStatus")
        })
        return _obj


